/*
 * kaffeinethumbnailer.h
 *
 * Copyright (C) 2008 Christophe Thommeret <hftom@free.fr>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
 */

#ifndef KAFFEINETHUMBNAILER_H
#define KAFFEINETHUMBNAILER_H

#include <xine.h>
#include <xine/xineutils.h>

#include <QFile>



class KaffeineThumb
{

public:

	KaffeineThumb();
	~KaffeineThumb();
	void takeShot( QString src, QString dst, int pos, int width );
	void takeShots( int pos, int width );
	bool readStdin();

	static void raw_output_cb( void *user_data, int frame_format, int frame_width,
		int frame_height, double frame_aspect, void *data0, void*, void* );
	static void raw_overlay_cb( void*, int, raw_overlay_t* ) {}

	bool takingShot;
	QString dstFile, srcFile;
	int thumbWidth;

private:

	xine_t *xine;
	xine_stream_t *stream;
	xine_video_port_t *voPort;
	xine_audio_port_t *aoPort;
	QFile inFile;
	char inBuf[1500];
};

#endif // KAFFEINETHUMBNAILER_H
